Attribute VB_Name = "modMain"
'2
Option Explicit

'====================
'First Proceed number 2, 3, 5 => there are of course Prime Number
'
' It's not neccessary to take in count all numbers to squared root
'of number as we could thought. I found an algorithm, where it's
'enough that we try the division(Mod) of only one number plus and
'one number minus. If we go after step 6, it will really find all
'given number.
'For ex. 6 to sqr(144)..
'1, 6 - 1 = 5  x Mod 5
'2, 6 + 1 = 7  x Mod 6
'3, Division of 6 => same as 2, because 6 = 2 * 3
'4, Division of 8 => same as 2, because 8 = 2 * 4
'5, Division of 9 => same as 3, because 9 = 3 * 3
'6, Division of 10 => same as 2 or 5, because 10 = 2 * 5
'7, Division of 11 => this number we'll check in next iteration
'I mean 12-1=>11 ..
Function IsPrimeNumber(ByVal n As Long) As Boolean
  Dim bIs As Boolean
  Dim i As Long
  
  bIs = True
    
  If n = 1 Then bIs = False 'Not a prime number
  
  If n Mod 2 = 0 And n <> 2 Then bIs = False 'Proceed
  If n Mod 3 = 0 And n <> 3 Then bIs = False 'Proceed
  If n Mod 5 = 0 And n <> 5 Then bIs = False 'Proceed
  
  For i = 6 To Sqr(n) Step 6
    If n Mod (i - 1) = 0 Then bIs = False
    If n Mod (i + 1) = 0 Then bIs = False
  Next i
    
  IsPrimeNumber = bIs
End Function

'Return all Prime Numbers in given Range and split them with ','
'for next use in Function (ex. Join, Split)
Function GetAllPrimeNumber(ByVal nLbound As Long, ByVal nUbound As Long) As String
  Dim i As Long
  Dim s As String
     
  For i = nLbound To nUbound
    If IsPrimeNumber(i) Then
      s = s & CStr(i) & ","
    End If
  Next i
  
  GetAllPrimeNumber = s
   
End Function

